#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

extern int curve[];
extern float sin_tbl[];
extern float tri_tbl[];
extern float saw_tbl[];
extern float sqa_tbl[];
extern float *wave_tbl;

gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  int i, phase = 0;
  float last_y = curve[0];

  gdk_window_clear_area (widget->window,
                         event->area.x, event->area.y,
                         event->area.width, event->area.height);
  gdk_gc_set_clip_rectangle (widget->style->fg_gc[widget->state],
                             &event->area);

  for (i=2; i<widget->allocation.width - 6; i++) {
    gdk_draw_line(widget->window, widget->style->fg_gc[widget->state], i, last_y, i+1, curve[phase]);

    last_y = curve[phase];
    if (++phase > 126) {
      phase = 0;
    }
  }

  gdk_gc_set_clip_rectangle (widget->style->fg_gc[widget->state],
                             NULL);

  return FALSE;
}


void
on_radiosin_pressed                    (GtkButton       *button,
                                        gpointer         user_data)
{
	wave_tbl = sin_tbl;
	calc_and_draw();
}


void
on_radiotri_pressed                    (GtkButton       *button,
                                        gpointer         user_data)
{
	wave_tbl = tri_tbl;
	calc_and_draw();
}


void
on_radiosaw_pressed                    (GtkButton       *button,
                                        gpointer         user_data)
{
	wave_tbl = saw_tbl;
	calc_and_draw();
}


void
on_radiosqr_pressed                    (GtkButton       *button,
                                        gpointer         user_data)
{
	wave_tbl = sqa_tbl;
	calc_and_draw();
}


gboolean
on_window1_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_main_quit();
  return FALSE;
}

